import org.junit.Assert;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import java.util.ArrayList;

public class PersonTest{
    private Person m1;
    private Person m2;    
    private Person m3;
    private Person m4; 
    private Person m5; 

    @Before
    public void setUp(){
        m1 = new Person("Ute",42);
        m2 = new Person("Ulf",43);
        m3 = new Person("Ida",44);
        m4 = new Person("Udo",45);
        m5 = new Person("Urs",46);
        m1.qualifikationHinzu("Java");
        m1.qualifikationHinzu("C");
        m2.qualifikationHinzu("C");
        m2.qualifikationHinzu("Java");
        m3.qualifikationHinzu("Java");
        m3.qualifikationHinzu("C");
        m3.qualifikationHinzu("C#");
        m4.qualifikationHinzu("PHP");
        m4.qualifikationHinzu("Java");
    }

    // Anmerkung: Aufteilung in einzelne Tests waere noch besser
    @Test
    public void testAnzahlQualifikationen(){
        Assert.assertTrue(m1.anzahlQualifikationen() == 2);
        Assert.assertTrue(m2.anzahlQualifikationen() == 2);
        Assert.assertTrue(m3.anzahlQualifikationen() == 3);
        Assert.assertTrue(m4.anzahlQualifikationen() == 2);
        Assert.assertTrue(m5.anzahlQualifikationen() == 0);
    }

    @Test
    public void testHatQualifikation(){
        Assert.assertTrue(m1.hatQualifikation("Java"));
        Assert.assertTrue(m2.hatQualifikation("Java"));
        Assert.assertTrue(m3.hatQualifikation("Java"));
        Assert.assertTrue(m4.hatQualifikation("Java"));
        Assert.assertTrue(!m5.hatQualifikation("Java"));
    }

    @Test
    public void testHatQualifikationen(){
        ArrayList<String> tmp = new ArrayList<String>();
        tmp.add("C");
        tmp.add("Java");
        Assert.assertTrue(m1.hatQualifikationen(tmp));
        Assert.assertTrue(m2.hatQualifikationen(tmp));
        Assert.assertTrue(m3.hatQualifikationen(tmp));
        Assert.assertTrue(!m4.hatQualifikationen(tmp));
        Assert.assertTrue(!m5.hatQualifikationen(tmp));
    }   

    @Test
    public void testQualifikationHinzu1(){
        m1.qualifikationHinzu("Java");
        Assert.assertTrue(m1.hatQualifikation("Java"));
        Assert.assertTrue(m1.anzahlQualifikationen() == 2);
    }

    @Test
    public void testQualifikationHinzu2(){
        m1.qualifikationHinzu("C#");
        Assert.assertTrue(m1.hatQualifikation("C#"));
        Assert.assertTrue(m1.anzahlQualifikationen() == 3);
    }
    
    @Test 
    public void testGleichQualifiziert1(){
        Assert.assertTrue(m1.gleichQualifiziert(m2));
    }

    @Test 
    public void testGleichQualifiziert2(){
        Assert.assertTrue(m1.gleichQualifiziert(m2));
        Assert.assertTrue(m1.gleichQualifiziert(m2));
    }

    @Test 
    public void testGleichQualifiziert3(){
        Assert.assertTrue(m2.gleichQualifiziert(m2));
        Assert.assertTrue(m2.gleichQualifiziert(m2));
    }
    
    @Test 
    public void testGleichQualifiziert4(){
        Assert.assertTrue(!m1.gleichQualifiziert(m3));
        Assert.assertTrue(!m3.gleichQualifiziert(m1));
    }
    
    @Test 
    public void testGleichQualifiziert5(){
        Assert.assertTrue(!m3.gleichQualifiziert(m4));
        Assert.assertTrue(!m4.gleichQualifiziert(m3));
    }
    
    @Test 
    public void testGleichQualifiziert6(){
        Assert.assertTrue(!m4.gleichQualifiziert(m5));
        Assert.assertTrue(!m5.gleichQualifiziert(m4));
    }
    
    @Test 
    public void testGleichQualifiziert7(){
        Assert.assertTrue(m5.gleichQualifiziert(m5));
        Assert.assertTrue(m5.gleichQualifiziert(m5));
    }
    
    @Test
    public void testBesserQualifiziertAls1(){
        Assert.assertTrue(!m1.besserQualifiziertAls(m2));
        Assert.assertTrue(!m2.besserQualifiziertAls(m1));
    }
    
    @Test
    public void testBesserQualifiziertAls2(){
        Assert.assertTrue(!m1.besserQualifiziertAls(m3));
        Assert.assertTrue(m3.besserQualifiziertAls(m1));
    }
    
    @Test
    public void testBesserQualifiziertAls3(){
        Assert.assertTrue(!m1.besserQualifiziertAls(m4));
        Assert.assertTrue(!m4.besserQualifiziertAls(m1));
    }
    
    @Test
    public void testBesserQualifiziertAls4(){
        Assert.assertTrue(!m3.besserQualifiziertAls(m4));
        Assert.assertTrue(!m4.besserQualifiziertAls(m3));
    }
    
    @Test
    public void testBesserQualifiziertAls5(){
        Assert.assertTrue(m1.besserQualifiziertAls(m5));
        Assert.assertTrue(!m5.besserQualifiziertAls(m1));
    }
    
    @Test
    public void testBesserQualifiziertAls6(){
        Assert.assertTrue(m4.besserQualifiziertAls(m5));
        Assert.assertTrue(!m5.besserQualifiziertAls(m4));
    }
    
    @Test
    public void testBesserQualifiziertAls7(){
        Assert.assertTrue(!m5.besserQualifiziertAls(m5));
        Assert.assertTrue(!m5.besserQualifiziertAls(m5));
    }
    
}
