import java.util.ArrayList;

public class Personalverwaltung {
    private ArrayList<Person> Person = new ArrayList<Person>();
    private EinUndAusgabe io = new EinUndAusgabe();

    public Personalverwaltung(){
        this.setUp();
        this.steuern();
    }

    public void setUp(){ // Beispieldaten zum Experimentieren
        Person m1 = new Person("Uwe",42);
        m1.qualifikationHinzu("Java");
        Person m2 = new Person("Ute",43);
        m2.qualifikationHinzu("Java");
        Person m3 = new Person("Olga",44);
        m3.qualifikationHinzu("Java");
        m3.qualifikationHinzu("C");
        Person m4 = new Person("Nabil",45);
        m4.qualifikationHinzu("C");
        Person m5 = new Person("Ida",46);
        m5.qualifikationHinzu("C");
        m5.qualifikationHinzu("Java");
        this.Person.add(m1);
        this.Person.add(m2);
        this.Person.add(m3);
        this.Person.add(m4);
        this.Person.add(m5);

    }

    public void steuern() {
        Integer ein = -1;
        EinUndAusgabe io = new EinUndAusgabe();
        while (ein != 0) {
            io.ausgeben(
                "N\u00e4chste Aktion:\n" + " (0) Programm beenden\n"
                + " (1) Neue Person einf\u00fcgen\n"
                + " (2) eine Person ausgeben\n"
                + " (3) alle Personen ausgeben\n"
                + " (4) Qualifikationen einer Person bearbeiten\n"
                + " (5) Person mit Qualifikation suchen\n"
                + " (6) Person loeschen\n"
                + " (7) Person vergleichen\n");
            ein = io.leseInteger();
            switch (ein) {
                case 0: {
                    break;
                }
                case 1: {
                    this.personEingeben();
                    break;
                }
                case 2: {
                    this.personAusgeben();
                    break;
                }
                case 3: {
                    this.allePersonen();
                    break;
                }
                case 4: {
                    this.qualifikationBearbeiten();
                    break;
                }
                case 5: {
                    this.personSuchen();
                    break;
                }
                case 6: {
                    this.personLoeschen();
                    break;
                }
                case 7: {
                    this.vergleichen();
                    break;
                }
                default: {
                    this.io.ausgeben("Zahl zwischen 0 und 7 eingeben\n");
                    break;
                }
            }
            io.ausgeben("\n");
        }
    }
    
    /** Methode prueft, ob die übergebene Personnummer bereits
     * an einen anderen verwalteten Person vergeben ist
     */
    public Boolean minrVorhanden(Integer minr){
        return suchen(minr) == null;
    }

    public void personEingeben(){
        this.io.ausgeben("Name: ");
        String n = this.io.leseString();
        Integer minr = null;
        while(minr==null){
            this.io.ausgeben("Personnummer: ");
            minr=this.io.leseInteger();
            if(minrVorhanden(minr)){
                minr = null;
                this.io.ausgeben("Nummer bereits vergeben.\n");
            }
        }
        Person m = new Person (n,minr);
        this.Person.add(m);
        io.ausgeben("neuer Person "+m+"\n");
    }

    public Person suchen(int pnr){
        for(Person m:this.Person){
            if(m.getPnr() == pnr){
                return m;
            }
        }
        return null;
    }

    public void personAusgeben(){
        this.io.ausgeben("Personalnummer: ");
        Person m = this.suchen(this.io.leseInteger());
        if(m==null){
            this.io.ausgeben("Person existiert nicht.\n");
        } else{
            this.io.ausgeben(m+"\n");
        }
    }

    public void allePersonen(){
        for(Person m:this.Person){
            this.io.ausgeben(m+"\n");
        }
    }

    public void qualifikationBearbeiten(){
        this.io.ausgeben("Personnummer: ");
        Person m = this.suchen(this.io.leseInteger());
        if(m==null){
            this.io.ausgeben("Person existiert nicht.\n");
        } else{
            qualifikationBearbeiten(m);
        }       
    }    

    public void qualifikationBearbeiten(Person m){
        this.io.ausgeben("neue Qualifikation: ");
        String art = this.io.leseString();
        if(m.hatQualifikation(art)){
            this.io.ausgeben("Qualifikation schon vorhanden.\n");
        } else {
            m.qualifikationHinzu(art);
        }
    } 

    public void personSuchen(){
        this.io.ausgeben("Qualifikation: ");
        String q = io.leseString();
        for(Person m:this.Person){
            if(m.hatQualifikation(q)){
                this.io.ausgeben(m+"\n");
            }
        }        
    }

    public Person loeschen(int pnr){
        Person m = suchen(pnr);
        this.Person.remove(m);
        return m;
    }

    public void personLoeschen(){
        this.io.ausgeben("Personnummer: ");
        Person m =this.loeschen(io.leseInteger());
        if(m==null){
            this.io.ausgeben("Person ohnehin nicht vorhanden.\n");
        } else {
            this.io.ausgeben("Geloescht: "+m+"\n");
        }
    }

    public void vergleichen(){
        this.io.ausgeben("Personalnummer: ");
        Person m = suchen(this.io.leseInteger());
        if(m==null){
            this.io.ausgeben("Person existiert nicht.\n");
        } else {
            for(Person ma:this.Person){
                if(m.gleichQualifiziert(ma)){
                    this.io.ausgeben(" gleich: "+ma+"\n");
                } else {
                    if(m.besserQualifiziertAls(ma)){
                        this.io.ausgeben(" schlechter: "+ma+"\n");
                    } else {
                        if (ma.besserQualifiziertAls(m)){
                            this.io.ausgeben(" besser: "+ma+"\n");
                        } else {
                            this.io.ausgeben(" unvergleichbar: "+ma+"\n");
                        }                       
                    }
                }
            }
        }

    }              
}

